class IntStack
{
  /*@ non_null @*/ int[] stack;
  int number; 

  //@ invariant 0 <= number && number <= stack.length;

  /*@ constraint (\forall int i; 0 <= i && i < number-1;
    @              stack[i] == \old(stack[i])); @*/

  final int N = 10;

  /*@ ensures stack.length == N
    @ && number == 0;
    @*/
  IntStack()
  {
    stack = new int[N];
    number = 0;
  }

  /*@ ensures \result <==> number == 0;
    @*/
  boolean isempty() 
  { 
    return number == 0; 
  }

  /*@ ensures number == \old(number)+1
    @ && stack[number-1] == e;
    @*/
  void push(int e) 
  { 
    if (number == stack.length) 
      resize();
    stack[number] = e;
    number = number+1;
  }

  /*@ requires number > 0;
    @ ensures number == \old(number)-1
    @ && \result == stack[number];
    @*/
  int pop(int e)
  {
    number = number-1;
    return stack[number];
  }

  /*@ ensures stack.length > \old(stack.length) 
    @ && number == \old(number)
    @ && (\forall int i; 0 <= i && i < number;
    @       stack[i] == \old(stack[i]));    
    @*/
  void resize()
  {
     int s[] = new int[2*stack.length+1];
     for (int i=0; i<stack.length; i++) 
       s[i] = stack[i];
     stack = s;
  }
}
