public abstract class IntStackBase
{
  /*@
    @ public model non_null IntStackModel stackM;
    @ public initially stackM.isempty();
    @
    @ represents stackM <- toModel(); 
    @ public model pure IntStackModel toModel();
    @*/

  /*@ public normal_behavior
    @   assignable stackM;
    @   ensures stackM.isempty();
    @*/
  public IntStackBase () 
  { 
  } //@ nowarn Post, Invariant; 
  // must be overridden

  /*@ public normal_behavior
    @   ensures \result <==> stackM.isempty(); 
    @*/
  public abstract /*@ pure @*/ boolean isempty();

  /*@ public normal_behavior
    @   assignable stackM;
    @   ensures stackM == \old(stackM.push(e));
    @*/
  public abstract void push(int e);

  /*@ public normal_behavior
    @   requires !isempty();
    @   assignable stackM;
    @   ensures \result == \old(stackM.top())
    @   && stackM == \old(stackM.pop()); 
    @*/
  public abstract int pop(int e);
}
