public interface IntStackInterface
{
  /*@
    @ public instance model non_null IntStackModel stackM;
    @ public initially stackM.isempty();
    @
    @ represents stackM <- toModel(); 
    @ public model pure IntStackModel toModel();
    @*/

  /*@ public normal_behavior
    @   assignable \nothing;
    @   ensures \result <==> stackM.isempty(); 
    @*/
  public /*@ pure @*/ boolean isempty();

  /*@ public normal_behavior
    @   assignable stackM;
    @   ensures stackM == \old(stackM.push(e));
    @*/
  public void push(int e);

  /*@ public normal_behavior
    @   requires !stackM.isempty();
    @   assignable stackM;
    @   ensures \result == \old(stackM.top())
    @   && stackM == \old(stackM.pop()); 
    @*/
  public int pop(int e);
}
