class Swap
{
  // swap the first two elements of a
  /*@ requires a != null && a.length > 1;
    @ modifies a[*];
    @ ensures a[0] == \old(a[1]) && a[1] == \old(a[0]);
    @ ensures (\forall int k; 2 <= k && k < a.length; a[k] == \old(a[k]));
    @*/
  static void swapFirst(int[] a)
  {
    swap(a, 0, 1);
  }

  // swap a[i] and a[j]
  /*@ requires a != null;
    @ requires 0 <= i && i < a.length;
    @ requires 0 <= j && j < a.length;
    @ modifies a[*];
    @ ensures a[i] == \old(a[j]) && a[j] == \old(a[i]);
    @ ensures (\forall int k; 2 <= k && k < a.length; 
    @            (k != i && k !=j) ==> a[k] == \old(a[k]));
    @*/
  static void swap(int[] a, int i, int j)
  {
    int t = a[i];
    a[i] = a[j];
    a[j] = t;
  }
}

    
